// ViewView.cpp : implementation of the CViewView class
//
#include <mmsystem.h>
#include "stdafx.h"

#include "eepreport.h"
#include "dclib.h"
#include "View.h"
#include "ViewDoc.h"
#include "ViewView.h"
#include "imglib.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define MULTI_CHANNEL

#define DWIDTH	1300	
#define DHEIGHT	1030

#define DISP_RATIO	1
#define FRAMES		2	// 150MB frame buffer for each channel 

#define WIDTH	(DWIDTH*DISP_RATIO)
#define HEIGHT	DHEIGHT		

#define Video	0

BYTE *mImage[2];

///////////////////////////////////////////////////////////////


BYTE image[DWIDTH*DHEIGHT*3];
BOOL bFlagDisplay = FALSE;
DWORD tImage[(DWIDTH*DHEIGHT)];

///////////////////////////////////////////////////////////////////

CRect rectImage(5, 5, DWIDTH+5, DHEIGHT+5);

///////////////////////////////////////////////////////////////////

UINT ThreadFunc(LPVOID lpData){

	int k;
	CViewView *pView = (CViewView *)lpData;
	int j,i;
	DWORD pos[2];
	int cnt;
	DWORD disppos=0;
	int cn = 0;

	char name[30];


	DC_CapSleep(cn,0,1);
	DC_CapSleep(cn,1,1);
	DC_CapRunning(cn,0);

	for (i=0;i<2;i++) {
		DC_SetMode(cn,i,
				1, // edge high
				0, // sync high
				0, // line area
				1, // 10bits
				0  // format 0 : 8bit
				);

		DC_SetH(cn,i,200,WIDTH-1);
		DC_SetV(cn,i,1,HEIGHT-1);
		DC_SetFlt(cn,i,0,0,0,0,0);
	}

	DC_SetSyncPara(cn,20,WIDTH+500,1,HEIGHT+10);
	DC_SetSyncGen(cn,
		1,	// sync_en
		0,	// sync high
		0,	// sync encoder sel
		1,	// sync clk sel
		1	// sync master
		);

	DC_WriteReg(cn,0x834,0);

	DC_CapSleep(cn,0,0);
	DC_CapSleep(cn,1,0);

	//DC_DmaRead(0,0,WIDTH*HEIGHT,WIDTH*HEIGHT*FRAMES);
	DC_DmaRead(0,0,WIDTH*HEIGHT,WIDTH*HEIGHT*FRAMES);
	//DC_DmaRead(0,0,0,WIDTH*HEIGHT);
	DC_DmaRead(0,1,WIDTH*HEIGHT,WIDTH*HEIGHT*FRAMES);
	DC_CapRunning(0,0x3);


	cnt = 0;
	// channel 0 display
	while(bFlagDisplay == TRUE){
		DC_GetDmaPosOvl(0,1,&(pos[0]));
		//if (disppos!=pos[0]) {
		//if (pos[0]==2) {
			disppos = pos[0];
			cnt++;
			RAWtoBMPImage((BYTE *)mImage[1]+(pos[0]-1)*WIDTH*HEIGHT, image, DWIDTH, DHEIGHT);
			pView->InvalidateRect(&rectImage, FALSE);
			//break;
		//}
	}
	DC_DmaStop(0,0);
	DC_DmaStop(0,1);
	DC_CapRunning(0,0);
	WriteBMPImage("img.bmp", image, DWIDTH,DHEIGHT);
	//WriteRAWImage("img.raw", (BYTE *)mImage21, WIDTH,HEIGHT);
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CViewView

IMPLEMENT_DYNCREATE(CViewView, CFormView)

BEGIN_MESSAGE_MAP(CViewView, CFormView)
	//{{AFX_MSG_MAP(CViewView)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewView construction/destruction

CViewView::CViewView()
	: CFormView(CViewView::IDD)
{
	//{{AFX_DATA_INIT(CViewView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	DC_Init();
	mImage[0] = DC_DmaAlloc(0,0,WIDTH*HEIGHT*FRAMES);
	mImage[1] = DC_DmaAlloc(0,1,WIDTH*HEIGHT*FRAMES);
}

CViewView::~CViewView()
{
	DC_End();
}

void CViewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewView)
	DDX_Control(pDX, IDC_BUTTON1, m_bnBegin);
	//}}AFX_DATA_MAP
}

BOOL CViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CViewView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CViewView diagnostics

#ifdef _DEBUG
void CViewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewDoc* CViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewDoc)));
	return (CViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewView message handlers

void CViewView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	BITMAPINFOHEADER m_bmiHdr;
	BITMAPFILEHEADER m_bmfHdr;

	MakeBMPHeader(&m_bmiHdr, &m_bmfHdr, DWIDTH, DHEIGHT);
	SetDIBitsToDevice(dc.m_hDC, 5, 5,	m_bmiHdr.biWidth, m_bmiHdr.biHeight,
						0, 0, 0, (WORD)m_bmiHdr.biHeight, image,
						(LPBITMAPINFO)&m_bmiHdr, BI_RGB);

	

}

void CViewView::OnButton1() 
{

	if ( bFlagDisplay == FALSE ) {
		bFlagDisplay = TRUE;

		AfxBeginThread(ThreadFunc, (LPVOID)this, THREAD_PRIORITY_NORMAL);
		m_bnBegin.SetWindowText("Stop");
	}
	else {
		bFlagDisplay = FALSE;
		m_bnBegin.SetWindowText("Display");
	}
}
