
#ifndef __DC_LIB_H_____
#define __DC_LIB_H_____

#ifdef __cplusplus
extern "C" {
#endif

#define	BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long

__declspec( dllexport ) int DC_Init();
__declspec( dllexport ) int DC_End();


__declspec( dllexport ) int DC_GetMaxCards();
__declspec( dllexport ) int DC_GetMaxChannels(int card_num);
__declspec( dllexport ) int DC_GetID(int card_num);

__declspec( dllexport ) int DC_WriteReg(int card_num,DWORD offset,DWORD data);
__declspec( dllexport ) int DC_ReadReg(int card_num,DWORD offset,DWORD *data);

__declspec( dllexport ) int DC_InIrqSet(int card_num,DWORD ipen, DWORD inen);
__declspec( dllexport ) int DC_InRead(int card_num,DWORD *data);
__declspec( dllexport ) int DC_InReadOvl(int card_num,DWORD *data,DWORD *status);
__declspec( dllexport ) int DC_CancelReadOvl(int card_num);

__declspec( dllexport ) int DC_OutWrite(int card_num,DWORD data);



__declspec( dllexport ) BYTE *DC_DmaAlloc(int card_num,int channel,DWORD size);
__declspec( dllexport ) void DC_DmaFree(int card_num,int channel);

__declspec( dllexport ) int DC_GetDmaPos(int card_num,int channel,DWORD *pos);
__declspec( dllexport ) int DC_GetDmaPosOvl(int card_num,int channel,DWORD *pos);

__declspec( dllexport ) int DC_CancelGetDmaPos(int card_num,int channel);
__declspec( dllexport ) int DC_WaitForDmaEnd(int card_num,int channel);
__declspec( dllexport ) int DC_DmaStop(int card_num,int channel);
__declspec( dllexport ) int DC_DmaRead(int card_num,int channel,DWORD intlength,DWORD length);


// eeprom program 
__declspec( dllexport ) void DC_SetRpt(int card_num,eepReport *report);
__declspec( dllexport ) int DC_Prog(int card_num,char *filename);



__declspec( dllexport ) int DC_CapSleep(int card_num,int channel,int OnOff);
__declspec( dllexport ) int DC_SetMode(int card_num,int channel,BYTE edgeHigh,BYTE SyncHigh,BYTE LineArea,BYTE Input10Bits,BYTE Format);
__declspec( dllexport ) int DC_SetFlt(int card_num,int channel,DWORD mode,DWORD fsHz,DWORD cutoffHz,int offset,DWORD q);
__declspec( dllexport ) int DC_SetH(int card_num,int channel,DWORD bp,DWORD active);
__declspec( dllexport ) int DC_SetV(int card_num,int channel,DWORD bp,DWORD active);
__declspec( dllexport ) int DC_SetLookupTable(int card_num,int channel,BYTE *table);

// sync generator & capture control

// encoder control
__declspec( dllexport ) int DC_SetEncoderDivisor(int card_num,int val);
__declspec( dllexport ) int DC_SetEncoderCounter(int card_num,DWORD val);
__declspec( dllexport ) int DC_GetEncoderCounter(int card_num,DWORD *val);

// sync 

__declspec( dllexport ) int DC_SetSyncGen(int card_num,int SyncEnable,int SyncHigh,int SyncEncSel, int SyncClkSel,int SyncMaster);
__declspec( dllexport ) int DC_SetSyncPara(int card_num,int Hsync,int Hnumbers, int Vsync,int Vnumbers);

// capture running controll
__declspec( dllexport ) int DC_CapRunning(int card_num,DWORD val);





#ifdef __cplusplus
}
#endif

#endif
